# Get the compatibility level that has been requested
# USAGE: compatibility_level
# RETURN: the requested compatibility level,
#         defaulting to the current library version
compatibility_level() {
	local compatibility_level

	if [ -n "${PLAYIT_COMPATIBILITY_LEVEL:-}" ]; then
		compatibility_level="$PLAYIT_COMPATIBILITY_LEVEL"
	elif [ -n "${target_version:-}" ]; then
		# FIXME: Find a way to show a deprecation warning *once*, not repeating it each time this function is called.
		#        The warning should be shown when the compatibility level is set to a value ≥ 2.26.
		compatibility_level="$target_version"
	else
		compatibility_level="$LIBRARY_VERSION"
	fi

	printf '%s' "$compatibility_level"
}

# Check the compatibility level against a given version
# USAGE: compatibility_level_is_at_least $minimum_version
# RETURN: 0 if the compatibility level is equal or superior to the given level,
#         1 if the compatibility level is inferior to the given level
compatibility_level_is_at_least() {
	local minimum_version compatibility_level
	minimum_version="$1"
	compatibility_level=$(compatibility_level)

	version_is_at_least "$minimum_version" "$compatibility_level"
}

